/*
Ben & Clara

The purpose of this code is to make our halloween pranking spider functional. The code will control LED's, servo motors, resistors, Serial communication,
an Ultrasonic sensor, pushbutton and a Passive Buzzer.

When a person rings the bell (pushbutton) a spider will drop down (servo motor), hopefully giving them a fright. Before the individual rings the bell
the case of the spider pranker will light up (LED's) as they approach the device (ultrasonic sensor).

*/

#include <Servo.h>
Servo servo;
int led1 = 5; //declaring variables
int led2 = 6;
int led3 = 7;
int sound = 250;
int trigPin = 9;
int echoPin = 8;

int servoPin = 13;
int buttonPin = 2;
int buzzerPin = 3;
int lastButtonState;    // the previous state of button
int currentButtonState; // the current state of button

void setup(){
  Serial.begin(9600); //begin serial communication

  servo.attach(servoPin); //attach the servo motor variable to a pin
  pinMode(buttonPin, INPUT); //declaring variables as inputs and outputs
  pinMode(buzzerPin, OUTPUT);
  pinMode(buttonPin, INPUT_PULLUP); // set arduino pin to input pull-up mode

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  currentButtonState = digitalRead(buttonPin); //read the current value of the button pin
}

void loop() {

long duration, distance; //long function, takes/stores extended/large variables both positive and negative.
digitalWrite(trigPin, LOW); //Clears the trigPin
delayMicroseconds(2); 
digitalWrite(trigPin, HIGH); // Sets the trigPin on HIGH state for 10 micro seconds
delayMicroseconds(10);
digitalWrite(trigPin, LOW); 
//Reads the echoPin, returns the sound wave travel time in microseconds

duration = pulseIn(echoPin, HIGH); //set the trigpin to high/On to sense things.
distance = duration * 0.034 / 2; //speed of sound formula 

if (distance < 80) { //if the distance of the pulse is less than 80cm it will turn on the LED's.
Serial.println("someone is at the button"); //prints message "" in serial monitor
digitalWrite(led1, HIGH);
digitalWrite(led2, HIGH);
digitalWrite(led3, HIGH);

}

else if (distance < 180) { //if the distance of the pulse is less than 180cm it will turn off the LED's.
Serial.println("someone has left the button");
digitalWrite(led1, LOW); 
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
}

delay(200);

//----------------------------------------------------------

  lastButtonState    = currentButtonState;      // save the last state
  currentButtonState = digitalRead(buttonPin); // read new state
  
  if(lastButtonState == HIGH && currentButtonState == LOW) {
    Serial.println("button pressed") ;
     //if 'lastButtonState' is 'HIGH'/on and the 'currentButtonState' is 'LOW'/off (==)
//and both operands are true (&&) turn the buzzer on/HIGH and turn the servo.
    
  digitalWrite(buzzerPin, HIGH); //turn the buzzer pin on, to start making sound
    
  servo.write(0);
  delay(1); 
  servo.write(360);
  delay(2000); 

  digitalWrite(buzzerPin, LOW); //buzzer pin turns off after servo motor ahs turned back to '0'
 
  servo.write(0);
  delay(1000);
 }
}
